package cz.muni.fi.pb162.cviceni;


/**
 * Implementace rozhrani Node.
 * 
 * @author Zuzana Neverilova
 * @version 1
 */
public class NodeImpl implements Node
{
    private String name;

    /**
     * Konstruktor
     * @param name jmeno uzlu
     * @throws NullPointerException, pokud je jmeno null
     */
    public NodeImpl(String name)
    {
        if (name == null)
            throw new NullPointerException("name");        
        this.name = name;
    }

    /**
     * Vrati jmeno uzlu
     * @return jmeno uzlu
     */
    public String getName()
    {
        return name;
    }
    
    /**
     * Porovnavani uzlu. Uzly jsou stejne prave tehdy, kdyz 
     * jsou oba uzly a maji stejne jmeno.
     * @param o objekt k porovnani
     */
    public boolean equals(Object o)
    {
        if (o instanceof Node)
            return ((Node)o).getName().equals(name);
        return false;
    }
    
    /**
     * Hashcode uzlu vrati hashCode jeho jmena.
     * @return hashcode uzlu
     */
    public int hashCode()
    {
        return name.hashCode();
    }
    
    /**
     * Textova reprezentace uzlu
     * @return jmeno uzlu
     */
    public String toString()
    {
        return name;
    }
    
}
